# Generated by Django 4.2.10 on 2024-02-14 21:24

from django.conf import settings
import django.contrib.auth.models
import django.contrib.auth.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import imagekit.models.fields
import markdownx.models
import projector.models.projects


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'}, help_text='Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=150, unique=True, validators=[django.contrib.auth.validators.UnicodeUsernameValidator()], verbose_name='username')),
                ('first_name', models.CharField(blank=True, max_length=150, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=150, verbose_name='last name')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='email address')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('avatar', imagekit.models.fields.ProcessedImageField(blank=True, null=True, upload_to='avatars')),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'abstract': False,
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('slug', models.SlugField(blank=True, max_length=100)),
                ('description', models.TextField()),
                ('users', models.ManyToManyField(to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('icon', imagekit.models.fields.ProcessedImageField(blank=True, null=True, upload_to='icons/')),
                ('title', models.CharField(max_length=250)),
                ('slug', models.SlugField(help_text='Must be unique. Used for URLs', max_length=250, unique=True, validators=[projector.models.projects.validate_project_slug])),
                ('api_key', models.CharField(default=projector.models.projects.make_api_key, help_text='Used for posting w/ hooks', max_length=64)),
                ('visible', models.BooleanField(default=True, help_text='Set this to false to not show up on the homepage.', verbose_name='Show on FAST website')),
                ('tagline', models.CharField(help_text='Short, catchy sentence about the project', max_length=100)),
                ('description', markdownx.models.MarkdownxField(help_text='Markdown-formatted project description')),
                ('project_created', models.DateField(help_text='The approximate date this project started development or was launched. Only year / term will be used by site.')),
                ('scope', models.CharField(blank=True, choices=[('Local', 'Local (Used by Faculty/Dept Internally)'), ('Cross-Department', 'Cross-Department (Invite only)'), ('Campus-Wide', 'Campus-Wide (Available to All)')], max_length=100)),
                ('url', models.CharField(blank=True, help_text='Link to project homepage. This will also act to whitelist a domain where the overlay tools can send emails from', max_length=256)),
                ('documentation_url', models.CharField(blank=True, help_text='A link to your USER-FACING documentation', max_length=256)),
                ('ticket_url', models.CharField(blank=True, help_text='A link, if one exists to the page for submitting tickets to this project', max_length=256)),
                ('gitlab_id', models.CharField(blank=True, help_text='This can be found under general project settings (its an integer). If you have a CHANGELOG.md file in the root of your repo it will be read.', max_length=100)),
                ('gitlab_access_token', models.CharField(blank=True, help_text="If the default gitlab API token won't work for you, provide an alternative", max_length=256)),
                ('gitlab_url', models.CharField(blank=True, help_text="If your project isn't in the UW git repo, you can provide an alternative gitlab url here.", max_length=256)),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('groups', models.ManyToManyField(help_text='Include or add all groups which work with this project from a development perspective', to='projector.group')),
            ],
        ),
        migrations.CreateModel(
            name='Technology',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('category', models.CharField(blank=True, choices=[('LANGUAGE', 'Language'), ('BACKEND', 'Backend Framework'), ('FRONTEND', 'Frontend Framework'), ('PLUGIN', 'Plugin (numpy, openCV, etc)')], max_length=100)),
                ('name', models.CharField(max_length=100)),
                ('slug', models.SlugField(blank=True, max_length=100)),
            ],
            options={
                'verbose_name': 'Technology',
                'verbose_name_plural': 'Technologies',
            },
        ),
        migrations.CreateModel(
            name='TrackedDocument',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=256)),
                ('slug', models.SlugField(max_length=256)),
                ('date_updated', models.DateTimeField(auto_now=True)),
                ('body', markdownx.models.MarkdownxField()),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('project', models.ForeignKey(help_text='Note: limited to projects for which you are a contact', on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
            ],
        ),
        migrations.AddField(
            model_name='project',
            name='technologies',
            field=models.ManyToManyField(blank=True, to='projector.technology'),
        ),
        migrations.CreateModel(
            name='ImpactSpec',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('score', models.IntegerField(default=0)),
                ('comments', models.TextField(blank=True)),
                ('summary', models.TextField()),
                ('public_users', models.BooleanField(default=False)),
                ('student_users', models.BooleanField(default=False)),
                ('staff_users', models.BooleanField(default=False)),
                ('faculty_users', models.BooleanField(default=False)),
                ('external_users', models.BooleanField(default=False)),
                ('api_users', models.BooleanField(default=False)),
                ('num_users', models.IntegerField(choices=[(10, '~10'), (100, '~100'), (1000, '~1000'), (10000, 'less than 10k'), (10001, '10k+'), (-1, 'unknown')])),
                ('critical_level', models.IntegerField(choices=[(5, 'CRITICAL'), (4, 'HIGH'), (3, 'MEDIUM'), (2, 'LOW'), (0, 'NOT USEFUL')])),
                ('private_information', models.TextField(blank=True)),
                ('risk_assessment', models.BooleanField(default=False)),
                ('last_update_author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('project', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='FallBack',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('override_first_name', models.CharField(blank=True, max_length=250)),
                ('override_last_name', models.CharField(blank=True, max_length=250)),
                ('override_email', models.EmailField(blank=True, max_length=254)),
                ('notes', models.TextField(help_text='additional notes reguarding fallback capabilities for this user')),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DocumentVersion',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_updated', models.DateTimeField()),
                ('body', models.TextField()),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('document', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='past_versions', to='projector.trackeddocument')),
            ],
            options={
                'ordering': ('-date_updated',),
            },
        ),
        migrations.CreateModel(
            name='Contributor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('override_first_name', models.CharField(blank=True, max_length=250)),
                ('override_last_name', models.CharField(blank=True, max_length=250)),
                ('override_email', models.EmailField(blank=True, max_length=254)),
                ('contributed_to', models.TextField(help_text='Quick summary of contributions, ex: co-op winter 2021, UX design, etc.')),
                ('role', models.CharField(blank=True, choices=[('Manager', 'Manager'), ('Stakeholder', 'Stakeholder'), ('Developer', 'Developer'), ('Co-op', 'Co-op')], max_length=100)),
                ('show_email', models.BooleanField(default=False)),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Contact',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('override_first_name', models.CharField(blank=True, max_length=250)),
                ('override_last_name', models.CharField(blank=True, max_length=250)),
                ('override_email', models.EmailField(blank=True, max_length=254)),
                ('contact_for', models.TextField(help_text='eg. general support / user support / server configuration. Will show up in overlays')),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
                ('user', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ChangeManagementSpec',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('score', models.IntegerField(default=0)),
                ('comments', models.TextField(blank=True)),
                ('repo_url', models.URLField(max_length=1024)),
                ('issue_locations', models.TextField(blank=True)),
                ('maintainer_1', models.EmailField(max_length=254)),
                ('maintainer_2', models.EmailField(blank=True, max_length=254)),
                ('has_dev_text', models.BooleanField(default=False)),
                ('has_deploy_text', models.BooleanField(default=False)),
                ('has_contributor_text', models.BooleanField(default=False)),
                ('has_license', models.BooleanField(default=False)),
                ('has_no_secrets', models.BooleanField(default=False)),
                ('last_update_author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('project', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='projector.project')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='user',
            name='contact_for',
            field=models.ManyToManyField(related_name='contact_users', through='projector.Contact', to='projector.project'),
        ),
        migrations.AddField(
            model_name='user',
            name='contributed_to',
            field=models.ManyToManyField(related_name='contributor_users', through='projector.Contributor', to='projector.project'),
        ),
        migrations.AddField(
            model_name='user',
            name='groups',
            field=models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.group', verbose_name='groups'),
        ),
        migrations.AddField(
            model_name='user',
            name='user_permissions',
            field=models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.permission', verbose_name='user permissions'),
        ),
    ]
